#!/usr/bin/env python
# -*- coding: UTF-8 -*-

import subprocess
import os

gcc_list=["3.4.6-r2","4.0.4","4.1.2","4.2.4-r1","4.3.2-r4","4.3.3-r2","4.3.4","4.4.1","4.4.2" ]
binutils_list=["2.16.1-r3","2.18-r4","2.19.1-r1","2.20"]    
uclibc_list=["0.9.28.3-r8","0.9.30","0.9.30.1-r1"]

def run_code(command,show=False):
	if show:
		print "Lanzo "+str(command)
	p = subprocess.Popen(command, shell=True)
	sts = os.waitpid(p.pid, 0)
	return sts[1]

to_emerge=["system","binutils","gcc","uclibc","bash","make","gzip","bzip2","unzip"]

salida=open("crossdev.txt","w")

delete_folder=True
contador=0
for e_gcc in gcc_list:
	for e_binutils in binutils_list:
		for e_uclibc in uclibc_list:
			salida.close()
			salida=open("crossdev.txt","a")
			contador+=1
			if delete_folder:
				retval=run_code("rm -rf /usr/mipsel-unknown-linux-uclibc")
				retval=run_code("crossdev -C mipsel-unknown-linux-uclibc")
				delete_folder=False
			versiones="--gcc "+e_gcc+" --binutils "+e_binutils+" --libc "+e_uclibc
			salida.write(str(contador)+": "+versiones+" ")
			retval=run_code("crossdev --target mipsel-unknown-linux-uclibc --without-headers "+versiones,True)
			if retval!=0:
				salida.write("Fail 1\n")
				continue
			delete_folder=True
			retval=run_code("emerge-wrapper --init")
			retval=run_code("echo \"sys-devel/gcc * ~*\" > /usr/mipsel-unknown-linux-uclibc/etc/portage/package.keywords")
			for elemento in to_emerge:
				if elemento=="gcc":
					elemento2="=gcc-"+e_gcc
				elif elemento=="binutils":
					elemento2="=binutils-"+e_binutils
				elif elemento=="uclibc":
					elemento2="=uclibc-"+e_uclibc
				else:
					elemento2=elemento
				retval=run_code("emerge-mipsel-unknown-linux-uclibc "+elemento2,True)
				if (retval!=0):
					salida.write("Fail "+elemento2+"\n")
					break
			if (retval==0):
				salida.write("Done\n")

salida.close()
				

